#include <algorithm>
#include <vector>
#include <iostream>
#include <set>
using ll = long long;
using namespace std;
int ans = 0;
void dfs(int lv, int v, vector<int>& g, vector<vector<int>>& s, int sn) {
    if (g[v] == 3 - sn) {
        ans++;
        g[v] = 3;
    } else {
        g[v] = sn;
        for (int i : s[v]) {
            if (i != lv && g[i] != 3 - sn) {
                dfs(v, i, g, s, 3 - sn);
                break;
            }
        }
    }
}
int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, x, nn;
    cin >> n;
    vector<vector<int>> v(n);
    vector<int> g(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> x;
        v[i].push_back(x - 1);
        v[x - 1].push_back(i);
    }
    while (count(g.begin(), g.end(), 0) != 0) {
        for (int i = 0; i < n; i++) {
            if (g[i] == 0) {
                nn = i;
                break;
            }
        }
        dfs(-1, nn, g, v, 1);
    }
    string a = "";
    string b = "";
    cout << ans << endl;
    for (int i = 0; i < n; i++) {
        if (g[i] == 1) {
            a += to_string(i + 1) + " ";
        } else if (g[i] == 2) {
            b += to_string(i + 1) + " ";
        }
    }
    cout << a << endl;
    cout << b << endl;
    return 0;
}